VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Image"
   ClientHeight    =   2655
   ClientLeft      =   495
   ClientTop       =   1050
   ClientWidth     =   3750
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   177
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   250
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const FName As String = "c:\test.mag"

Private Type Makichan2Header
HeaderStart As Byte
MachineCode As Byte
MachineFlags As Byte
ScreenMode As Byte
XOffset As Integer
YOffset As Integer
XMax As Integer
YMax As Integer
HeaderOffsetToFlagA As Long
HeaderOffsetToFlagB As Long
SizeOfFlagB As Long
HeaderOffsetToColorIndexStream As Long
SizeOfColorIndexStream As Long
Palette(2, 255) As Byte
End Type

Private Type BITMAPINFOHEADER '40 bytes
biSize As Long
biWidth As Long
biHeight As Long
biPlanes As Integer
biBitCount As Integer
biCompression As Long
biSizeImage As Long
biXPelsPerMeter As Long
biYPelsPerMeter As Long
biClrUsed As Long
biClrImportant As Long
End Type

Private Type RGBQUAD
rgbBlue As Byte
rgbGreen As Byte
rgbRed As Byte
rgbReserved As Byte
End Type

Private Type BITMAPINFO
bmiHeader As BITMAPINFOHEADER
bmiColors(255) As RGBQUAD
End Type

Private Declare Function SetDIBits Lib "gdi32.dll" ( _
    ByVal hDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, _
    ByVal nNumScans As Long, ByRef lpBits As Any, _
    ByRef lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Dim DeltaX(15) As Byte
Dim DeltaY(15) As Byte



Private Sub Form_Initialize()
DeltaX(0) = 0
DeltaX(1) = 1
DeltaX(2) = 2
DeltaX(3) = 4
DeltaX(4) = 0
DeltaX(5) = 1
DeltaX(6) = 0
DeltaX(7) = 1
DeltaX(8) = 2
DeltaX(9) = 0
DeltaX(10) = 1
DeltaX(11) = 2
DeltaX(12) = 0
DeltaX(13) = 1
DeltaX(14) = 2
DeltaX(15) = 0
DeltaY(0) = 0
DeltaY(1) = 0
DeltaY(2) = 0
DeltaY(3) = 0
DeltaY(4) = 1
DeltaY(5) = 1
DeltaY(6) = 2
DeltaY(7) = 2
DeltaY(8) = 2
DeltaY(9) = 4
DeltaY(10) = 4
DeltaY(11) = 4
DeltaY(12) = 8
DeltaY(13) = 8
DeltaY(14) = 8
DeltaY(15) = 16
End Sub

Private Sub Form_Load()
Dim FileTypeCheck As String * 6
Dim BmInf As BITMAPINFO
Dim MagH As Makichan2Header
Dim FlagAGetter() As Byte
Dim FlagA() As Byte
Dim FlagB() As Byte
Dim ColorIndexStream() As Integer

Dim WholeFileForTesting() As Byte
Dim StartingPoint As Long



Dim PicW As Long
Dim PicW2 As Long
Dim PicH As Long

If Dir(FName) = "" Then End
Open FName For Binary Access Read As #1
ReDim WholeFileForTesting(1 To LOF(1))
Get #1, 1, FileTypeCheck
If FileTypeCheck <> "MAKI02" Then
Close #1
End
End If
Get #1, 1, WholeFileForTesting()
For n = 1 To LOF(1)
If WholeFileForTesting(n) = &H1A Then
StartingPoint = n + 1
Exit For
End If
Next n
Get #1, StartingPoint, MagH
PicW = MagH.XMax - MagH.XOffset + 1
PicW2 = Ceil(PicW / 8) * 8
PicH = MagH.YMax - MagH.YOffset + 1
ShowSpecs MagH

If MagH.ScreenMode > 127 Then ReDim FlagAGetter((PicW2 * PicH) \ 32) Else ReDim FlagAGetter((PicW2 * PicH) \ 64)
ReDim FlagA((UBound(FlagAGetter) + 1) * 8 - 1)
Get #1, StartingPoint + MagH.HeaderOffsetToFlagA, FlagAGetter()

ReDim FlagB(MagH.SizeOfFlagB - 1)
Get #1, StartingPoint + MagH.HeaderOffsetToFlagB, FlagB()

ReDim ColorIndexStream((MagH.SizeOfColorIndexStream \ 2) - 1)
Get #1, StartingPoint + MagH.HeaderOffsetToColorIndexStream, ColorIndexStream()
Close #1



For i = 0 To UBound(FlagAGetter)
For b = 0 To 7
FlagA(i * 8 + b) = (FlagAGetter(i) \ (2 ^ (7 - b))) And 1
Next b
Next i


Dim FlagBuffer() As Byte
If MagH.ScreenMode > 127 Then ReDim FlagBuffer((PicW2 \ 4) - 1) Else ReDim FlagBuffer((PicW2 \ 8) - 1)
Dim Pix() As Integer
If MagH.ScreenMode > 127 Then ReDim Pix((PicW2 \ 2) - 1, PicH - 1) Else ReDim Pix((PicW2 \ 4) - 1, PicH - 1)
Dim XScanScaler As Long
If MagH.ScreenMode > 127 Then XScanScaler = 4 Else XScanScaler = 8


z0 = 0
z = 0
z2 = 0
For y = 0 To PicH - 1
For x = 0 To (PicW2 \ XScanScaler) - 1
If FlagA(z0) Then
FlagBuffer(x) = FlagBuffer(x) Xor FlagB(z)
z = z + 1
End If


i = (FlagBuffer(x) \ 16) And 15
If i = 0 Then
Pix(x * 2, y) = ColorIndexStream(z2)
z2 = z2 + 1
Else
Pix(x * 2, y) = Pix(x * 2 - DeltaX(i), y - DeltaY(i))
End If

i = FlagBuffer(x) And 15
If i = 0 Then
Pix(x * 2 + 1, y) = ColorIndexStream(z2)
z2 = z2 + 1
Else
Pix(x * 2 + 1, y) = Pix(x * 2 + 1 - DeltaX(i), y - DeltaY(i))
End If


z0 = z0 + 1
Next x
Next y

Dim PalSize As Integer
If (MagH.ScreenMode \ 128) And 1 Then
PalSize = 256
ElseIf (MagH.ScreenMode \ 2) And 1 Then
PalSize = 8
Else
PalSize = 16
End If

For i = 0 To PalSize - 1
BmInf.bmiColors(i).rgbGreen = MagH.Palette(0, i)
BmInf.bmiColors(i).rgbRed = MagH.Palette(1, i)
BmInf.bmiColors(i).rgbBlue = MagH.Palette(2, i)
Next i

With BmInf.bmiHeader
.biWidth = PicW
.biHeight = -PicH
If MagH.ScreenMode > 127 Then .biBitCount = 8 Else .biBitCount = 4
.biSize = 40
.biPlanes = 1
End With
Me.Width = (PicW + (Me.Width \ Screen.TwipsPerPixelX) - Me.ScaleWidth) * Screen.TwipsPerPixelX
Me.Height = (PicH + (Me.Height \ Screen.TwipsPerPixelY) - Me.ScaleHeight) * Screen.TwipsPerPixelY
SetDIBits Me.hDC, Me.Image, 0, PicH, Pix(0, 0), BmInf, 0


End Sub




Private Function Ceil(ByVal Value As Double) As Long
If Int(Value) < Value Then Ceil = Int(Value) + 1 Else Ceil = Value
End Function


Private Sub ShowSpecs(ByRef MagHeader As Makichan2Header)
Load Form2
With MagHeader
If (.ScreenMode \ 1) And 1 Then
Form2.Label1.Caption = "Display Vertical Res: 200"
Else
Form2.Label1.Caption = "Display Vertical Res: 400"
End If

If (.ScreenMode \ 128) And 1 Then
Form2.Label2.Caption = "Palette Size: 256"
ElseIf (.ScreenMode \ 2) And 1 Then
Form2.Label2.Caption = "Palette Size: 8"
Else
Form2.Label2.Caption = "Palette Size: 16"
End If

If (.ScreenMode \ 4) And 1 Then
Form2.Label3.Caption = "Expected Display Type: Digital"
Else
Form2.Label3.Caption = "Expected Display Type: Analog"
End If

Form2.Label4.Caption = "Image Size (W x H): " & CStr(.XMax - .XOffset + 1) & "x" & CStr(.YMax - .YOffset + 1)

End With

Form2.Show
End Sub

Private Sub Form_Unload(Cancel As Integer)
End
End Sub
